unit Splines;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, Tabnotbk, StdCtrls, ExtCtrls, Menus, ExtDlgs, FileCtrl;

type
  TForm1 = class(TForm)
    gCrtaj: TButton;
    gkraj: TButton;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Exit1: TMenuItem;
    GroupBox1: TGroupBox;
    TrackBar1: TTrackBar;
    wvr: TLabel;
    Label3: TLabel;
    Crtaj1: TMenuItem;
    Kraj1: TMenuItem;
    Spremikao1: TMenuItem;
    Kraj2: TMenuItem;
    Label2: TLabel;
    vvr: TLabel;
    TrackBar2: TTrackBar;
    Label5: TLabel;
    Edit1: TEdit;
    GroupBox2: TGroupBox;
    Gdodajt: TButton;
    Label6: TLabel;
    Xtocka: TEdit;
    Label7: TLabel;
    ytocka: TEdit;
    Label1: TLabel;
    gobrisi: TButton;
    SaveDialog1: TSaveDialog;
    OpenDialog1: TOpenDialog;
    DirectoryListBox1: TDirectoryListBox;
    GroupBox3: TGroupBox;
    Image1: TImage;
    Mogunosti1: TMenuItem;
    Bojalinije1: TMenuItem;
    Bojatoke1: TMenuItem;
    ColorDialog1: TColorDialog;
    Pomo1: TMenuItem;
    Oautoru1: TMenuItem;
    procedure gkrajClick(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure TrackBar2Change(Sender: TObject);
    procedure GdodajtClick(Sender: TObject);
    procedure gCrtajClick(Sender: TObject);
    procedure gobrisiClick(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure Spremikao1Click(Sender: TObject);
    procedure Crtaj1Click(Sender: TObject);
    procedure Kraj1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure Bojalinije1Click(Sender: TObject);
    procedure Bojatoke1Click(Sender: TObject);
    procedure Oautoru1Click(Sender: TObject);
    
  private
    { Private declarations }
  public
    { Public declarations }
  end;
  const max=200;
  type tocka=record
        x,y:real;
        end;
  type niz=array[1..max] of real;


var
  Form1: TForm1;
  tocke:array[1..max] of tocka;
  w,v:array[1..max] of integer;
  dx,dy:array[1..max] of real;
  t,fin:integer;
  tocolor,lcolor:TColor;
  rtocke:integer;
  ymax,ymin,xratio,yratio:real;
  fileName,path:string;
implementation

uses about;


{$R *.DFM}

procedure vektori;
var     c,r:array[1..max] of real;
        i:integer;
        xtemp1,ytemp1,xtemp2,ytemp2,fact:real;
begin
        c[1]:=w[1]/(tocke[2].x-tocke[1].x);
        r[1]:=0.5*v[1]+2*c[1];
        dx[1]:=3*c[1]*(tocke[2].x-tocke[1].x);
        dy[1]:=3*c[1]*(tocke[2].y-tocke[1].y);
        xtemp1:=dx[1];
        ytemp1:=dy[1];
        for i:=2 to t-1 do
        begin
                c[i]:=w[i]/(tocke[i+1].x-tocke[i].x);
                fact:=c[i-1]/r[i-1];
                r[i]:=0.5*v[i]+2*(c[i-1]+c[i])-c[i-1]*fact;
                xtemp2:=3*c[i]*(tocke[i+1].x-tocke[i].x);
                ytemp2:=3*c[i]*(tocke[i+1].y-tocke[i].y);
                dx[i]:=xtemp1+xtemp2-fact*dx[i-1];
                dy[i]:=ytemp1+ytemp2-fact*dy[i-1];
                xtemp1:=xtemp2;
                ytemp1:=ytemp2;
        end;
        fact:=c[t-1]/r[t-1];
        r[t]:=0.5*v[t]+2*c[t-1]-c[t-1]*fact;
        dx[t]:=xtemp1-fact*dx[t-1];
        dy[t]:=ytemp1-fact*dy[t-1];
        dx[t]:=dx[t]/r[t];
        dy[t]:=dy[t]/r[t];
        for i:=t-1 downto 1 do
        begin
                dx[i]:=(dx[i]-c[i]*dx[i+1])/r[i];
                dy[i]:=(dy[i]-c[i]*dy[i+1])/r[i];
        end;
end;

procedure TForm1.gkrajClick(Sender: TObject);
begin
       Application.Terminate;
end;

procedure TForm1.TrackBar1Change(Sender: TObject);
var     q:variant;
        x0,y0,x1,y1,dx0,dy0,dx1,dy1,xe,ye:real;
        i,j,n,a,b:integer;
begin
        if t>1 then
        begin
        {brisanje krivulje}
        q:=TrackBar1.Position;
        wvr.Caption:=q;
        q:=Edit1.Text;
        Val(q,i,j);
        if (q<>'') and (j=0) then
        begin
        vektori;
        image1.Canvas.Pen.Color:=toColor;
        for i:=1 to t do
        begin
                a:=round((tocke[i].x-tocke[1].x)*xratio)+30;
                b:=image1.height-30-round((tocke[i].y-ymin)*yratio);
                image1.Canvas.Ellipse(a-rtocke,b-rtocke,a+rtocke,b+rtocke);
        end;
        image1.Canvas.Pen.Color:=clWhite;
        image1.Canvas.MoveTo(30,image1.height-30-round((tocke[1].y-ymin)*yratio));
        for i:=1 to t-1 do
        begin
                x0:=tocke[i].x;
                y0:=tocke[i].y;
                x1:=tocke[i+1].x;
                y1:=tocke[i+1].y;
                dx0:=dx[i]*(tocke[i+1].x-tocke[i].x);
                dy0:=dy[i]*(tocke[i+1].x-tocke[i].x);
                dx1:=dx[i+1]*(tocke[i+1].x-tocke[i].x);
                dy1:=dy[i+1]*(tocke[i+1].x-tocke[i].x);
                n:=round((tocke[i+1].x-tocke[i].x)*fin/(tocke[t].x-tocke[1].x));
                for j:=1 to n do
                begin
                        xe:=x0*sqr(1-j/(n+1))*(2*j/(n+1)+1)+x1*sqr(j/(n+1))*(3-2*j/(n+1))+dx0*j/(n+1)*sqr(1-j/(n+1))+dx1*sqr(j/(n+1))*(j/(n+1)-1);
                        ye:=y0*sqr(1-j/(n+1))*(2*j/(n+1)+1)+y1*sqr(j/(n+1))*(3-2*j/(n+1))+dy0*j/(n+1)*sqr(1-j/(n+1))+dy1*sqr(j/(n+1))*(j/(n+1)-1);
                        image1.Canvas.LineTo(round((xe-tocke[1].x)*xratio)+30,image1.height-30-round((ye-ymin)*yratio));
                end;
                image1.Canvas.LineTo(round((tocke[i+1].x-tocke[1].x)*xratio)+30,image1.height-30-round((tocke[i+1].y-ymin)*yratio));
        end;
        {ponovno crtanje krivulje s novim parametrima}

        with Image1.Canvas do
        begin
                Pen.Color:=clBlack;
                MoveTo(30,10);
                LineTo(30,Image1.height-30);
                LineTo(Image1.width-10,Image1.height-30);
                LineTo(Image1.width-10,10);
                LineTo(30,10);
        end;
        i:=q;
        w[i]:=TrackBar1.Position;
        vektori;

        image1.Canvas.Pen.Color:=lColor;
        image1.Canvas.MoveTo(30,image1.height-30-round((tocke[1].y-ymin)*yratio));
        for i:=1 to t-1 do
        begin
                x0:=tocke[i].x;
                y0:=tocke[i].y;
                x1:=tocke[i+1].x;
                y1:=tocke[i+1].y;
                dx0:=dx[i]*(tocke[i+1].x-tocke[i].x);
                dy0:=dy[i]*(tocke[i+1].x-tocke[i].x);
                dx1:=dx[i+1]*(tocke[i+1].x-tocke[i].x);
                dy1:=dy[i+1]*(tocke[i+1].x-tocke[i].x);
                n:=round((tocke[i+1].x-tocke[i].x)*fin/(tocke[t].x-tocke[1].x));
                for j:=1 to n do
                begin
                        xe:=x0*sqr(1-j/(n+1))*(2*j/(n+1)+1)+x1*sqr(j/(n+1))*(3-2*j/(n+1))+dx0*j/(n+1)*sqr(1-j/(n+1))+dx1*sqr(j/(n+1))*(j/(n+1)-1);
                        ye:=y0*sqr(1-j/(n+1))*(2*j/(n+1)+1)+y1*sqr(j/(n+1))*(3-2*j/(n+1))+dy0*j/(n+1)*sqr(1-j/(n+1))+dy1*sqr(j/(n+1))*(j/(n+1)-1);
                        image1.Canvas.LineTo(round((xe-tocke[1].x)*xratio)+30,image1.height-30-round((ye-ymin)*yratio));
                end;
                image1.Canvas.LineTo(round((tocke[i+1].x-tocke[1].x)*xratio)+30,image1.height-30-round((tocke[i+1].y-ymin)*yratio));
        end;
        end;
        end;
end;


procedure TForm1.FormCreate(Sender: TObject);
var i,a:integer;
begin
        with Image1.Canvas do
        begin
                Create;
                MoveTo(30,10);
                LineTo(30,Image1.height-30);
                LineTo(Image1.width-10,Image1.height-30);
                LineTo(Image1.width-10,10);
                LineTo(30,10);
        end;
        i:=80;
        a:=Image1.Height-30;
        while i<image1.Width-10 do
        begin
                image1.Canvas.MoveTo(i,a);
                image1.Canvas.LineTo(i,a+3);
                i:=i+50;
        end;
        i:=30;
        a:=a-45;
        while a>10 do
        begin
                image1.Canvas.MoveTo(i,a);
                image1.Canvas.LineTo(i-3,a);
                a:=a-45;
        end;
        for i:=1 to max do
        begin
                tocke[i].x:=0;
                tocke[i].y:=0;
                w[i]:=1;
                v[i]:=0;
        end;
        t:=0;
        tocolor:=clRed;
        lColor:=clBlue;
        rtocke:=2;
        fin:=500;
        fileName:='untitled';
        path:=directoryListBox1.Directory;
        path:=path+'\blank.bmp';
        groupBox3.Caption:=fileName;
end;

procedure TForm1.TrackBar2Change(Sender: TObject);
var     q:variant;
        ys,x0,y0,x1,y1,dx0,dy0,dx1,dy1,xe,ye:real;
        i,j,n,a,b:integer;
begin
        if t>1 then
        begin
        q:=TrackBar2.Position;
        vvr.Caption:=q;
        q:=Edit1.Text;
        val(q,i,j);
        if (q<>'') and (j=0) then
        begin
        image1.Canvas.Pen.Color:=clWhite;
        image1.Canvas.MoveTo(30,image1.height-30-round((tocke[1].y-ymin)*yratio));
        for i:=1 to t-1 do
        begin
                x0:=tocke[i].x;
                y0:=tocke[i].y;
                x1:=tocke[i+1].x;
                y1:=tocke[i+1].y;
                dx0:=dx[i]*(tocke[i+1].x-tocke[i].x);
                dy0:=dy[i]*(tocke[i+1].x-tocke[i].x);
                dx1:=dx[i+1]*(tocke[i+1].x-tocke[i].x);
                dy1:=dy[i+1]*(tocke[i+1].x-tocke[i].x);
                n:=round((tocke[i+1].x-tocke[i].x)*fin/(tocke[t].x-tocke[1].x));
                for j:=1 to n do
                begin
                        xe:=x0*sqr(1-j/(n+1))*(2*j/(n+1)+1)+x1*sqr(j/(n+1))*(3-2*j/(n+1))+dx0*j/(n+1)*sqr(1-j/(n+1))+dx1*sqr(j/(n+1))*(j/(n+1)-1);
                        ye:=y0*sqr(1-j/(n+1))*(2*j/(n+1)+1)+y1*sqr(j/(n+1))*(3-2*j/(n+1))+dy0*j/(n+1)*sqr(1-j/(n+1))+dy1*sqr(j/(n+1))*(j/(n+1)-1);
                        image1.Canvas.LineTo(round((xe-tocke[1].x)*xratio)+30,image1.height-30-round((ye-ymin)*yratio));
                end;
                image1.Canvas.LineTo(round((tocke[i+1].x-tocke[1].x)*xratio)+30,image1.height-30-round((tocke[i+1].y-ymin)*yratio));
        end;
        i:=q;
        v[i]:=TrackBar1.Position;
        vektori;
        image1.Canvas.Pen.Color:=toColor;
        for i:=1 to t do
        begin
                a:=round((tocke[i].x-tocke[1].x)*xratio)+30;
                b:=image1.height-30-round((tocke[i].y-ymin)*yratio);
                image1.Canvas.Ellipse(a-rtocke,b-rtocke,a+rtocke,b+rtocke);
        end;

        image1.Canvas.Pen.Color:=lColor;
        image1.Canvas.MoveTo(30,image1.height-30-round((tocke[1].y-ymin)*yratio));
        for i:=1 to t-1 do
        begin
                x0:=tocke[i].x;
                y0:=tocke[i].y;
                x1:=tocke[i+1].x;
                y1:=tocke[i+1].y;
                dx0:=dx[i]*(tocke[i+1].x-tocke[i].x);
                dy0:=dy[i]*(tocke[i+1].x-tocke[i].x);
                dx1:=dx[i+1]*(tocke[i+1].x-tocke[i].x);
                dy1:=dy[i+1]*(tocke[i+1].x-tocke[i].x);
                n:=round((tocke[i+1].x-tocke[i].x)*fin/(tocke[t].x-tocke[1].x));
                for j:=1 to n do
                begin
                        xe:=x0*sqr(1-j/(n+1))*(2*j/(n+1)+1)+x1*sqr(j/(n+1))*(3-2*j/(n+1))+dx0*j/(n+1)*sqr(1-j/(n+1))+dx1*sqr(j/(n+1))*(j/(n+1)-1);
                        ye:=y0*sqr(1-j/(n+1))*(2*j/(n+1)+1)+y1*sqr(j/(n+1))*(3-2*j/(n+1))+dy0*j/(n+1)*sqr(1-j/(n+1))+dy1*sqr(j/(n+1))*(j/(n+1)-1);
                        image1.Canvas.LineTo(round((xe-tocke[1].x)*xratio)+30,image1.height-30-round((ye-ymin)*yratio));
                end;
                image1.Canvas.LineTo(round((tocke[i+1].x-tocke[1].x)*xratio)+30,image1.height-30-round((tocke[i+1].y-ymin)*yratio));
        end;
        end;
        end;
end;

procedure TForm1.GdodajtClick(Sender: TObject);
var     s:string;
        p,i:integer;
        greska:boolean;
begin
        label1.Caption:='';
        greska:=false;
        t:=t+1;
        s:=xtocka.Text;
        Val(s,tocke[t].x,p);
        if p>0 then greska:=true;
        s:=ytocka.Text;
        Val(s,tocke[t].y,p);
        if p>0 then greska:=true;
        if greska then
        begin
                label1.Font.Color:=clRed;
                label1.Caption:='Greka u unosu';
                t:=t-1;
        end
        else
        begin
                for i:=1 to t-1 do
                       if tocke[i].x=tocke[t].x then
                       greska:=true;
                if greska then
                begin
                label1.Font.Color:=clRed;
                label1.Caption:='Greka u unosu';
                t:=t-1;
                end
                else
                begin
                label1.Font.Color:=clBlack;
                label1.Caption:='Toka je dodana';
                end;
        end;
        xtocka.Text:='';
        ytocka.Text:='';
        tabOrder
end;

procedure TForm1.gCrtajClick(Sender: TObject);
var i,j,a,b,n:integer;
        pom:tocka;
        xs,ys,x0,y0,x1,y1,dx0,dy0,dx1,dy1,xe,ye,p:real;
        s:string;
begin

        if t>1 then
        begin
        for i:=1 to t-1 do
                for j:=i+1 to t do
                        if tocke[i].x>tocke[j].x then
                        begin
                                pom:=tocke[i];
                                tocke[i]:=tocke[j];
                                tocke[j]:=pom;
                        end;
        xs:=abs(tocke[t].x-tocke[1].x);
        xratio:=(image1.Width-45)/xs;
        vektori;
        {raunaje njvee i najmanje vrijednosti funkcije zbog izraunavanja koeficijenta yratio}
        ymax:=tocke[1].y;
        ymin:=ymax;
        for i:=1 to t-1 do
        begin
                y0:=tocke[i].y;
                y1:=tocke[i+1].y;
                dy0:=dy[i]*(tocke[i+1].x-tocke[i].x);
                dy1:=dy[i+1]*(tocke[i+1].x-tocke[i].x);
                n:=round((tocke[i+1].x-tocke[i].x)*fin/(tocke[t].x-tocke[1].x));
                for j:=1 to n do
                begin
                        ye:=y0*sqr(1-j/(n+1))*(2*j/(n+1)+1)+y1*sqr(j/(n+1))*(3-2*j/(n+1))+dy0*j/(n+1)*sqr(1-j/(n+1))+dy1*sqr(j/(n+1))*(j/(n+1)-1);
                        if ye<ymin then ymin:=ye;
                        if ye>ymax then ymax:=ye;
                end;
                if tocke[i+1].y<ymin then ymin:=tocke[i+1].y;
                if tocke[i+1].y>ymax then ymax:=tocke[i+1].y;
        end;
        {ispisivanje vrijednosti toaka na koordinatnim osima}
        {x os}
        i:=30;
        p:=0;
        a:=Image1.Height-20;
        while i<=image1.Width-10 do
        begin
                str((tocke[1].x+p):4:2,s);
                image1.Canvas.TextOut(i-length(s)*2,a,s);
                p:=p+(tocke[t].x-tocke[1].x)/10;
                i:=i+50;
        end;
        {y os}
        i:=0;
        p:=0;
        a:=Image1.Height-30;
        while a>=10 do
        begin
                str((ymin+p):4:2,s);
                image1.Canvas.TextOut(i,a-5,s);
                p:=p+abs(ymax-ymin)/10;
                a:=a-45;
        end;
        {ctanje grafa}
        ys:=abs(ymax-ymin);
        yratio:=(image1.height-45)/ys;
        image1.Canvas.Pen.Color:=toColor;
        for i:=1 to t do
        begin
                a:=round((tocke[i].x-tocke[1].x)*xratio)+30;
                b:=image1.height-30-round((tocke[i].y-ymin)*yratio);
                image1.Canvas.Ellipse(a-rtocke,b-rtocke,a+rtocke,b+rtocke);
        end;

        image1.Canvas.Pen.Color:=lColor;
        image1.Canvas.MoveTo(30,image1.height-30-round((tocke[1].y-ymin)*yratio));
        for i:=1 to t-1 do
        begin
                x0:=tocke[i].x;
                y0:=tocke[i].y;
                x1:=tocke[i+1].x;
                y1:=tocke[i+1].y;
                dx0:=dx[i]*(tocke[i+1].x-tocke[i].x);
                dy0:=dy[i]*(tocke[i+1].x-tocke[i].x);
                dx1:=dx[i+1]*(tocke[i+1].x-tocke[i].x);
                dy1:=dy[i+1]*(tocke[i+1].x-tocke[i].x);
                n:=round((tocke[i+1].x-tocke[i].x)*fin/(tocke[t].x-tocke[1].x));
                for j:=1 to n do
                begin
                        xe:=x0*sqr(1-j/(n+1))*(2*j/(n+1)+1)+x1*sqr(j/(n+1))*(3-2*j/(n+1))+dx0*j/(n+1)*sqr(1-j/(n+1))+dx1*sqr(j/(n+1))*(j/(n+1)-1);
                        ye:=y0*sqr(1-j/(n+1))*(2*j/(n+1)+1)+y1*sqr(j/(n+1))*(3-2*j/(n+1))+dy0*j/(n+1)*sqr(1-j/(n+1))+dy1*sqr(j/(n+1))*(j/(n+1)-1);
                        image1.Canvas.LineTo(round((xe-tocke[1].x)*xratio)+30,image1.height-30-round((ye-ymin)*yratio));
                end;
                image1.Canvas.LineTo(round((tocke[i+1].x-tocke[1].x)*xratio)+30,image1.height-30-round((tocke[i+1].y-ymin)*yratio));
        end;
        end;
end;

procedure TForm1.gobrisiClick(Sender: TObject);
begin
                image1.Picture.LoadFromFile(path);
end;

procedure TForm1.Edit1Change(Sender: TObject);
var     i:integer;
        q:variant;
begin
        q:=edit1.Text;
        i:=q;
        TrackBar1.Position:=w[i];
        TrackBar2.Position:=v[i];
end;

procedure TForm1.Spremikao1Click(Sender: TObject);
var dat:textFile;
        i:integer;
begin
        if SaveDialog1.Execute then
        begin
                AssignFile(dat,saveDialog1.FileName);
                fileName:=SaveDialog1.FileName;
                rewrite(dat);
                writeln(dat,t);
                for i:=1 to t do
                        write(dat,tocke[i].x,' ');
                writeln(dat);
                for i:=1 to t do
                        write(dat,tocke[i].y,' ');
                writeln(dat);
                for i:=1 to t do
                        write(dat,w[i],' ');
                writeln(dat);
                for i:=1 to t do
                        write(dat,v[i],' ');
                writeln(dat);
                writeln(dat,lColor);
                writeln(dat,toColor);
                CloseFile(dat);
                GroupBox3.Caption:=FileName;
        end;
end;

procedure TForm1.Crtaj1Click(Sender: TObject);
var     dat:textFile;
        i,j,a,b,n:integer;
        pom:tocka;
        xs,ys,x0,y0,x1,y1,dx0,dy0,dx1,dy1,xe,ye,p:real;
        s:string;
begin
        if OpenDialog1.Execute then
        begin
                AssignFile(dat,OpenDialog1.FileName);
                fileName:=OpenDialog1.FileName;
                reset(dat);
                readln(dat,t);
                for i:=1 to t do
                        read(dat,tocke[i].x);
                readln(dat);
                for i:=1 to t do
                        read(dat,tocke[i].y);
                readln(dat);
                for i:=1 to t do
                        read(dat,w[i]);
                readln(dat);
                for i:=1 to t do
                        read(dat,v[i]);
                readln(dat);
                readln(dat,lColor);
                readln(dat,toColor);
        closeFile(dat);
        xs:=abs(tocke[t].x-tocke[1].x);
        xratio:=(image1.Width-45)/xs;
        vektori;
        {raunaje njvee i najmanje vrijednosti funkcije zbog izraunavanja koeficijenta yratio}
        ymax:=tocke[1].y;
        ymin:=ymax;
        for i:=1 to t-1 do
        begin
                y0:=tocke[i].y;
                y1:=tocke[i+1].y;
                dy0:=dy[i]*(tocke[i+1].x-tocke[i].x);
                dy1:=dy[i+1]*(tocke[i+1].x-tocke[i].x);
                n:=round((tocke[i+1].x-tocke[i].x)*fin/(tocke[t].x-tocke[1].x));
                for j:=1 to n do
                begin
                        ye:=y0*sqr(1-j/(n+1))*(2*j/(n+1)+1)+y1*sqr(j/(n+1))*(3-2*j/(n+1))+dy0*j/(n+1)*sqr(1-j/(n+1))+dy1*sqr(j/(n+1))*(j/(n+1)-1);
                        if ye<ymin then ymin:=ye;
                        if ye>ymax then ymax:=ye;
                end;
                if tocke[i+1].y<ymin then ymin:=tocke[i+1].y;
                if tocke[i+1].y>ymax then ymax:=tocke[i+1].y;
        end;
        {ispisivanje vrijednosti toaka na koordinatnim osima}
        {x os}
        i:=30;
        p:=0;
        a:=Image1.Height-20;
        while i<=image1.Width-10 do
        begin
                str((tocke[1].x+p):4:2,s);
                image1.Canvas.TextOut(i-length(s)*2,a,s);
                p:=p+(tocke[t].x-tocke[1].x)/10;
                i:=i+50;
        end;
        {y os}
        i:=0;
        p:=0;
        a:=Image1.Height-30;
        while a>=10 do
        begin
                str((ymin+p):4:2,s);
                image1.Canvas.TextOut(i,a-5,s);
                p:=p+abs(ymax-ymin)/10;
                a:=a-45;
        end;
        {ctanje grafa}
        ys:=abs(ymax-ymin);
        yratio:=(image1.height-45)/ys;
        image1.Canvas.Pen.Color:=toColor;
        for i:=1 to t do
        begin
                a:=round((tocke[i].x-tocke[1].x)*xratio)+30;
                b:=image1.height-30-round((tocke[i].y-ymin)*yratio);
                image1.Canvas.Ellipse(a-rtocke,b-rtocke,a+rtocke,b+rtocke);
        end;

        image1.Canvas.Pen.Color:=lColor;
        image1.Canvas.MoveTo(30,image1.height-30-round((tocke[1].y-ymin)*yratio));
        for i:=1 to t-1 do
        begin
                x0:=tocke[i].x;
                y0:=tocke[i].y;
                x1:=tocke[i+1].x;
                y1:=tocke[i+1].y;
                dx0:=dx[i]*(tocke[i+1].x-tocke[i].x);
                dy0:=dy[i]*(tocke[i+1].x-tocke[i].x);
                dx1:=dx[i+1]*(tocke[i+1].x-tocke[i].x);
                dy1:=dy[i+1]*(tocke[i+1].x-tocke[i].x);
                n:=round((tocke[i+1].x-tocke[i].x)*fin/(tocke[t].x-tocke[1].x));
                for j:=1 to n do
                begin
                        xe:=x0*sqr(1-j/(n+1))*(2*j/(n+1)+1)+x1*sqr(j/(n+1))*(3-2*j/(n+1))+dx0*j/(n+1)*sqr(1-j/(n+1))+dx1*sqr(j/(n+1))*(j/(n+1)-1);
                        ye:=y0*sqr(1-j/(n+1))*(2*j/(n+1)+1)+y1*sqr(j/(n+1))*(3-2*j/(n+1))+dy0*j/(n+1)*sqr(1-j/(n+1))+dy1*sqr(j/(n+1))*(j/(n+1)-1);
                        image1.Canvas.LineTo(round((xe-tocke[1].x)*xratio)+30,image1.height-30-round((ye-ymin)*yratio));
                end;
                image1.Canvas.LineTo(round((tocke[i+1].x-tocke[1].x)*xratio)+30,image1.height-30-round((tocke[i+1].y-ymin)*yratio));
        end;
        end;
        GroupBox3.Caption:=FileName;
end;

procedure TForm1.Kraj1Click(Sender: TObject);
var     dat:TextFile;
        i:integer;
begin
        if fileName='untitled' then
        begin
                if SaveDialog1.Execute then
                begin
                AssignFile(dat,saveDialog1.FileName);
                fileName:=SaveDialog1.FileName;
                rewrite(dat);
                writeln(dat,t);
                for i:=1 to t do
                        write(dat,tocke[i].x,' ');
                writeln(dat);
                for i:=1 to t do
                        write(dat,tocke[i].y,' ');
                writeln(dat);
                for i:=1 to t do
                        write(dat,w[i],' ');
                writeln(dat);
                for i:=1 to t do
                        write(dat,v[i],' ');
                writeln(dat);
                writeln(dat,lColor);
                writeln(dat,toColor);
                CloseFile(dat);
                GroupBox3.Caption:=FileName;
                end;
        end
        else
        begin
                AssignFile(dat,FileName);
                rewrite(dat);
                writeln(dat,t);
                for i:=1 to t do
                        write(dat,tocke[i].x,' ');
                writeln(dat);
                for i:=1 to t do
                        write(dat,tocke[i].y,' ');
                writeln(dat);
                for i:=1 to t do
                        write(dat,w[i],' ');
                writeln(dat);
                for i:=1 to t do
                        write(dat,v[i],' ');
                writeln(dat);
                writeln(dat,lColor);
                writeln(dat,toColor);
                CloseFile(dat);
        end;
end;
procedure TForm1.Exit1Click(Sender: TObject);
begin
        Image1.Picture.LoadFromFile(path);
        t:=0;
        fileName:='untitled';
        GroupBOx3.Caption:=fileName;
end;

procedure TForm1.Bojalinije1Click(Sender: TObject);
begin
        if ColorDialog1.Execute then
                lColor:=colorDialog1.Color;
end;

procedure TForm1.Bojatoke1Click(Sender: TObject);
begin
        if colorDialog1.Execute then
                toColor:=colorDialog1.Color;
end;

procedure TForm1.Oautoru1Click(Sender: TObject);
begin
        AboutBox.Show;
end;



end.
